import java.io.*;	
import java.awt.*;	
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;

public class JBottomBar extends JReorderPanel 
						implements ActionListener, ChangeListener {

	I18N 		messages 	= I18N.getInstance();
	JFiraFont 	fira 		= JFiraFont.getInstance();

	private final Color myWhite = new Color(250,250,250);

	private JBinomial parent = null;

	public JKSlider	singleKslider;
	public JKField	singleKvalue;
	
	public JMinMaxSlider 	minMaxSlider;
	public JKField			minKvalue, maxKvalue;

	public	JSigmaSlider 	sigmaSlider;
	public	JSliderCombo 	sigmaBox;
	private	JMuSigmaLabel	muValue;
	private	JMuSigmaLabel	sigmaValue;

	public	JSliderCombo 	hypoType;
	public	JSliderCombo 	hypoBox;
	public	JHypoSlider 	hypoSlider;
	
	
	JPanel	cardPanel,

			singleKpanel, intervalKpanel, sigmaPanel, hypoPanel;

	JReorderPanel buttonPanel;

	int 	k1Value;
	Double	sigmaAvalue, hypoValue; 

	public JShowButton showButton, lrButton; 

	public JActionButton fullButton, optButton, tableButton;

	public Boolean	setK1fromBox = false;

	private JActionButton createButton(String picname) {
		JActionButton button = new JActionButton(picname);      
		button.setBorder( BorderFactory.createEmptyBorder(0,8,0,8) );
		button.addActionListener( parent );
		buttonPanel.add(button); return button;
	}

	public JBottomBar (JBinomial pp) {
		parent = pp;
		setBackground( myWhite );
		setPreferredSize(new Dimension(0, 56));

		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));


		cardPanel = new JPanel( new CardLayout() );
		cardPanel.setBorder( BorderFactory.createEmptyBorder(0,20,0,20) );
		cardPanel.setBackground( myWhite );

		// panel for single k value:

		singleKslider = new JKSlider( 20, 10 );
		singleKslider.addChangeListener(parent);
		singleKslider.addChangeListener(this);

		singleKvalue = new JKField( this, "10", 3 );

		JPanel singleKpanel = new JPanel();
		singleKpanel.setLayout(new BoxLayout(singleKpanel, BoxLayout.X_AXIS));
		singleKpanel.setBackground( myWhite );

		singleKpanel.add( new JKLabel("k = ") );
		singleKpanel.add(Box.createRigidArea(new Dimension(5,0)));
		singleKpanel.add(singleKvalue);
		singleKpanel.add(Box.createRigidArea(new Dimension(20,0)));
		singleKpanel.add(singleKslider);

		cardPanel.add( singleKpanel, "single" );

		// panel for interval values:

		minKvalue = new JKField( this, "5", 3);
		maxKvalue = new JKField( this, "15", 3);

		minMaxSlider = new JMinMaxSlider(0, 20, 5, 15);
		minMaxSlider.addChangeListener(parent);
		minMaxSlider.addChangeListener(this);
		
		JPanel intervalKpanel = new JPanel();
		intervalKpanel.setLayout(new BoxLayout(intervalKpanel, BoxLayout.X_AXIS));
		intervalKpanel.setBackground( myWhite );

		intervalKpanel.add(minKvalue);
		intervalKpanel.add(Box.createRigidArea(new Dimension(5,0)));
		intervalKpanel.add( new JKLabel("≤ k ≤") );
		intervalKpanel.add(Box.createRigidArea(new Dimension(5,0)));
		intervalKpanel.add(maxKvalue);
		intervalKpanel.add(Box.createRigidArea(new Dimension(20,0)));
		intervalKpanel.add(minMaxSlider);

		cardPanel.add( intervalKpanel, "interval" );

		// panel for sigma value:

		sigmaSlider = new JSigmaSlider( this );

		Object[] spattern = new Object[] {
         "3", String.format("%1.2f", 2.58), 
         "2", String.format("%1.2f", 1.96),
			  String.format("%1.2f", 1.64), "1"
		};

		muValue		= new JMuSigmaLabel("10,25", "00,00");
		sigmaValue 	= new JMuSigmaLabel("2,34", "0,00");
		sigmaValue.setForeground(Color.red);
		sigmaBox 	= new JSigmaCombo(this, "1", spattern, 3);	
		
		JPanel sigmaPanel = new JPanel();
		sigmaPanel.setLayout(new BoxLayout(sigmaPanel, BoxLayout.X_AXIS));
		sigmaPanel.setBackground( myWhite );

		sigmaPanel.add( new JKLabel("μ = ") );
		sigmaPanel.add( muValue );
		sigmaPanel.add( Box.createRigidArea(new Dimension(10,0)) );
		sigmaPanel.add( new JKLabel("δ = ") );
		sigmaPanel.add( sigmaValue );

		sigmaPanel.add(Box.createRigidArea(new Dimension(20,0)));

		sigmaPanel.add( new JKLabel("a = ") );
		sigmaPanel.add( Box.createRigidArea(new Dimension(5,0)));
		sigmaPanel.add( sigmaBox );
		sigmaPanel.add( Box.createRigidArea(new Dimension(20,0)));
		sigmaPanel.add( sigmaSlider );

		cardPanel.add( sigmaPanel, "sigma" );

		// panel for hypo test:

		Object[] hpattern = new Object[] {
			"H₀: p₀ = p / H₁: p₁ ≠ p", 
			"H₀: p₀ ≥ p / H₁: p₁ < p", 
			"H₀: p₀ ≤ p / H₁: p₁ > p"
		};

		hypoType = new JSigmaCombo(parent, null, hpattern, 15);	

		Object[] apattern = new Object[] {
			"10%", "5%", String.format("%1.1f", 2.5)+"%", "2%", "1%"
		};

		hypoBox 	= new JSigmaCombo(this, "5%", apattern, 4);	

		hypoSlider	= new JHypoSlider();
		hypoSlider.addChangeListener( this );
		
		JPanel hypoPanel = new JPanel();
		hypoPanel.setLayout(new BoxLayout(hypoPanel, BoxLayout.X_AXIS));
		hypoPanel.setBackground( myWhite );

		hypoPanel.add( hypoType );
		hypoPanel.add( Box.createRigidArea(new Dimension(20,0)) );
		hypoPanel.add( new JKLabel("α = ") );
		hypoPanel.add( Box.createRigidArea(new Dimension(5,0)));
		hypoPanel.add( hypoBox );
		hypoPanel.add( Box.createRigidArea(new Dimension(20,0)));
		hypoPanel.add( hypoSlider );

		cardPanel.add( hypoPanel, "hypo" );


		add( cardPanel );

		buttonPanel = new JReorderPanel();
		buttonPanel.setBackground( myWhite );
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.setBorder( BorderFactory.createEmptyBorder(0,20,0,20) );

		addControls();

		add( buttonPanel );
		
		setStartLabel(singleKslider, 0,20,2);
		setStartLabel(minMaxSlider, 0,20,2);
	}


	private void addControls() {

		showButton = new JShowButton("eye-color", "eye-gray");
		showButton.setBorder( BorderFactory.createEmptyBorder(0,8,0,8) );
		showButton.setToolTipText( messages.getStr("tooltip.show") );

		buttonPanel.add(showButton); showButton.addActionListener( parent );

		tableButton = createButton("table");
		tableButton.setToolTipText( messages.getStr("tooltip.table") );
		
		optButton = createButton("opt");
		optButton.setToolTipText( messages.getStr("tooltip.optimum") );
		
		fullButton = createButton("full");
		fullButton.setToolTipText( messages.getStr("tooltip.full") );

		lrButton = new JShowButton("hand-right", "hand-left");
		lrButton.setBorder( BorderFactory.createEmptyBorder(0,8,0,8) );
		lrButton.setToolTipText( messages.getStr("tooltip.leftright") );
		buttonPanel.add(lrButton); lrButton.addActionListener( parent );
	}

	//---------------------------------------------------------

	public void changeLR(  ) {

		reOrder(); buttonPanel.reOrder();

	}

	//---------------------------------------------------------

	public void setPanel(int newPanel) {

		CardLayout cl = (CardLayout)(cardPanel.getLayout());
		
		switch( newPanel ) {
			
			case 0:
			case 1: cl.show( cardPanel, "single" );   break;
			case 2: cl.show( cardPanel, "interval" ); break;
			case 3: cl.show( cardPanel, "sigma" );    break;
			case 4: cl.show( cardPanel, "hypo" );     break;
		}
		
	}

	//---------------------------------------------------------

	public void actionPerformed (ActionEvent event){

		if ( (event.getSource() == singleKvalue) && isK1boxValid() ) {
				setK1Slider( getK1box() );
		}

		if ( (event.getSource() == minKvalue) && isIntervalValid() ) {
				minMaxSlider.setValue( Integer.parseInt( minKvalue.getText() ) );
		}

		if ( (event.getSource() == maxKvalue) && isIntervalValid() ) {
				minMaxSlider.setUpperValue( Integer.parseInt( maxKvalue.getText() ) );
		}

		if ( (event.getSource() == sigmaBox) && isSigmaValid() ) {
				sigmaSlider.setValue( (int)(sigmaAvalue*100.0) );
		}

		if ( (event.getSource() == hypoBox) && isHypoValid() ) {
				hypoSlider.setValue( (int)(hypoValue*10.0) );
		}

	}

	public void stateChanged(ChangeEvent e) {

		String s;

        if ( e.getSource() == singleKslider ) {
				setK1box();
		}

        if ( e.getSource() == sigmaSlider ) {
			s = String.format("%.2f", 1.0*sigmaSlider.getValue()/100 );

			if ( s.matches("[0-9][\\.,][1-9]0$") ) { 
				s = s.substring(0, s.length()-1 );
			} else if ( s.matches("[0-9]+[\\.,]00$") ) { 
			    s = s.substring(0, s.length()-3 );
			}

			sigmaBox.textField.setText( s );
		}

        if ( e.getSource() == minMaxSlider ) {
			minKvalue.setText( ""+minMaxSlider.getValue() );
			maxKvalue.setText( ""+minMaxSlider.getUpperValue() );
		}

        if ( e.getSource() == hypoSlider ) {
			hypoBox.textField.setText( ""+hypoSlider.getValueString() );
		}

	}

	//---------------------------------------------------------

	public void setK1box() {

		singleKvalue.setForeground(Color.black);
		singleKvalue.setText( ""+singleKslider.getValue() );

	}
	
	public Boolean isK1boxValid() {

		Boolean isValid = false;  String s = singleKvalue.getText();
		
		if ( s.matches("^ *1?[0-9]?[0-9] *$") ) {

			k1Value = Integer.parseInt( s );
			isValid = k1Value <= singleKslider.getMaximum();
		}

		if ( !isValid ) { singleKvalue.setForeground(Color.red); } 
		else { singleKvalue.setForeground(Color.black);	}

		return isValid;

	}

	public int getK1box() {
		return k1Value;
	}

	public void setK1Slider( int nn ) {

		singleKslider.setValue( nn );

	}
	
	public int getK1Slider( ) {

		return singleKslider.getValue();

	}


	public Boolean isIntervalValid() {

		Boolean isValid = false;  
		
		String s1 = minKvalue.getText();
		String s2 = maxKvalue.getText();
		
		int s1i = 0;
		int s2i = 0;
		
		if ( s1.matches("^ *[0-9]+ *$") ) {

			s1i = Integer.parseInt( s1 ) ;
			isValid = s1i >= minMaxSlider.getMinimum();
		}

		if ( !isValid ) { minKvalue.setForeground(Color.red); } 
		else { minKvalue.setForeground(Color.black);	}

		if ( isValid && (s2.matches("^ *[0-9]+ *$") ) ) {

			s2i = Integer.parseInt( s2 ) ;
			isValid = s2i <= minMaxSlider.getMaximum();

			if ( !isValid ) { maxKvalue.setForeground(Color.red); } 
					   else { maxKvalue.setForeground(Color.black);	}

		}

		if ( isValid && ( s2i < s1i ) ) {

			minKvalue.setForeground(Color.red);
			maxKvalue.setForeground(Color.red);
			isValid = false;

		}

		return isValid;

	}

	public int getIntervalSliderMin( ) { return minMaxSlider.getValue(); }
	public int getIntervalSliderMax( ) { return minMaxSlider.getUpperValue(); }



	public Boolean isSigmaValid() {

		Boolean isValid = false;  String s = sigmaBox.textField.getText();
		
		if ( s.matches("^ *[0-3]([\\.,][0-9]+)? *$") ) {

			sigmaAvalue = Math.round( Double.parseDouble( s.replaceAll(",",".") ) *100.0)/100.0 ;
			isValid = sigmaAvalue <= 3.0;
		}

		if ( !isValid ) { sigmaBox.textField.setForeground(Color.red); } 
		else { sigmaBox.textField.setForeground(Color.black);	}

		return isValid;

	}


	public Double getSigmaAvalue() {
		return (1.0*sigmaSlider.getValue())/100;
	}


	public Boolean isHypoValid() {

		Boolean isValid = false;  String s = hypoBox.textField.getText();
		
		if ( s.matches("^ *[0-9]+([\\.,][0-9]+)? *% *$") ) {

			hypoValue = Math.round( Double.parseDouble( 
				s.substring(0, s.indexOf("%") ).replaceAll(",",".") 
						) *10.0)/10.0 ;

			isValid = ( hypoValue <= 10.0 ) && ( hypoValue >= 1.0 );
		}

		if ( !isValid ) { hypoBox.textField.setForeground(Color.red); } 
		else { hypoBox.textField.setForeground(Color.black);	}

		return isValid;

	}



	int labelStart;

	private void setStartLabel(JSlider j, int kmin, int kmax, int x) {
		if ( (kmin%x)==0) { labelStart=kmin; } else { labelStart=x*(kmin/x+1); }
		j.setLabelTable( j.createStandardLabels( x, labelStart ) );
	}

	public void setMinMax( int kmin, int kmax ) {

		// single slider:

		int actk = singleKslider.getValue();

		singleKslider.setMinimum(kmin);
		singleKslider.setMaximum(kmax);

		if ( actk > kmax ) { singleKslider.setValue(kmax); }
		if ( actk < kmin ) { singleKslider.setValue(kmin); }
		
		if      ( kmax - kmin > 50 ) { setStartLabel(singleKslider, kmin, kmax, 10); }
		else if ( kmax - kmin > 20 ) { setStartLabel(singleKslider, kmin, kmax, 5);  }
		else if ( kmax - kmin > 10 ) { setStartLabel(singleKslider, kmin, kmax, 2);  }
		else 						 { setStartLabel(singleKslider, kmin, kmax, 1);  }

		singleKslider.setMinorForWheel();

		// interval slider:

		int actk1 = minMaxSlider.getValue();
		int actk2 = minMaxSlider.getUpperValue();

		minMaxSlider.setMinimum(kmin);
		minMaxSlider.setMaximum(kmax);

		if ( actk2 > kmax ) { minMaxSlider.setUpperValue(kmax); }
		if ( actk1 < kmin ) { minMaxSlider.setValue(kmin);      }

		if      ( kmax - kmin > 50 ) { setStartLabel(minMaxSlider, kmin, kmax, 10); }
		else if ( kmax - kmin > 20 ) { setStartLabel(minMaxSlider, kmin, kmax, 5);  }
		else if ( kmax - kmin > 10 ) { setStartLabel(minMaxSlider, kmin, kmax, 2);  }
		else 						 { setStartLabel(minMaxSlider, kmin, kmax, 1);  }


	}

	public void setMuSigma( Double mu, Double sigma ) {

		String s = String.format( "%.2f", mu);
		
		if ( s.matches("[0-9]+[\\.,][1-9]0$") ) { 
			muValue.setText( s.substring(0, s.length()-1 ) );
		} else if ( s.matches("[0-9]+[\\.,]00$") ) { 
			muValue.setText( s.substring(0, s.length()-3 ) );
		} else muValue.setText( s );

		s = String.format( "%.2f", sigma);
		
		if ( s.matches("[0-9]+[\\.,][1-9]0$") ) { 
			sigmaValue.setText( s.substring(0, s.length()-1 ) );
		} else if ( s.matches("[0-9]+[\\.,]00$") ) { 
			sigmaValue.setText( s.substring(0, s.length()-3 ) );
		} else sigmaValue.setText( s );

		if ( sigma > 3.0 ) { sigmaValue.setForeground( Color.blue ); }
					  else { sigmaValue.setForeground( Color.red  ); }
	}

	//---------------------------------------------------------

	private class JKLabel extends JLabel {

		public JKLabel(String s) {
			super( s );
			setFont( fira.font22 );
		}

	}
	
	//---------------------------------------------------------

	private class JMuSigmaLabel extends JKLabel {

		int xWidth = 0;
		
		public JMuSigmaLabel(String s, String pattern) {
			super( s );
			setForeground( Color.blue );
			
			FontMetrics fm = getFontMetrics( getFont() );
			xWidth = fm.stringWidth( pattern );
		}

		@Override
		public Dimension getPreferredSize() {
			Dimension d = super.getPreferredSize();
			d.width = xWidth;
			return d;
		}

		@Override
		public Dimension getMinimumSize() {
			return getPreferredSize();
		}

		@Override
		public Dimension getMaximumSize() {
			return getPreferredSize();
		}

	}
	
	//---------------------------------------------------------

	private class JKField extends JTextField {

		public JKField(ActionListener p, String s, int w) {
			super(s,w);
			setFont( fira.font22 );
			setHorizontalAlignment(JTextField.CENTER);
			addActionListener(p);
		}
		
		@Override
		public Dimension getMaximumSize() {
			return getPreferredSize();
		}
		
		
	}

	//---------------------------------------------------------

	public class JKSlider extends JWheelSlider {

		public JKSlider(int max, int val) {
			super( JSlider.HORIZONTAL, 0, max, val );
			setFont( fira.font18 );
			setMinorForWheel();
			setPaintLabels(true);
		}

		public void setMinorForWheel() {

			int kmax = getMaximum();
			int kmin = getMinimum();

			if      ( kmax - kmin > 50 ) { setMinorTickSpacing(5); }
			else if ( kmax - kmin > 20 ) { setMinorTickSpacing(2);  }
			else 						 { setMinorTickSpacing(1);  }
		}

	}

	//---------------------------------------------------------

	public class JSigmaSlider extends JWheelSlider {

		public JSigmaSlider(ChangeListener p) {
			super( JSlider.HORIZONTAL, 0, 300, 100 );
			setFont( fira.font18 );
			setPaintLabels(true);
			
			setMajorTickSpacing(50);
			setMinorTickSpacing(10);
			setPaintTicks(true);

			Hashtable<Integer, JLabel> labelTable = new Hashtable<Integer, JLabel>();

			for (int i=0; i<7; i++) {
				labelTable.put( new Integer( i*50 ), new JSigmaTickLabel( String.format("%.1f",(1.0*i)/2) ));
			}

			setLabelTable( labelTable );
			
			addChangeListener(parent);
			if ( p != null ) { addChangeListener(p); }
		}

		private class JSigmaTickLabel extends JLabel {

			public JSigmaTickLabel(String s) {
				super( s );
				setFont( fira.font18 );
			}

		}



	}


	private class JSigmaCombo extends JSliderCombo {

		public JSigmaCombo( ActionListener p, String start, 
						    Object[] pattern, int width) {
			super( null, (ActionListener)p, start, pattern, width);
		}

		@Override
		public Dimension getMaximumSize() {
			return getPreferredSize();
		}


	}


	public class JMinMaxSlider extends RangeSlider {

		public JMinMaxSlider(int min, int max, int k1, int k2) {
			super(min, max);
			setFont( fira.font18 );
			setValue(k1); setUpperValue(k2);
			setLabelTable( createStandardLabels( 2, 0 ) );
			setPaintLabels(true);
			setBackground( myWhite );
		}
		

	}


	public class JHypoSlider extends JWheelSlider {

		public JHypoSlider() {
			super( JSlider.HORIZONTAL, 10, 100, 50 );
			setFont( fira.font18 );
//			setFont( new Font("sansserif", Font.BOLD, 14) );

			Hashtable<Integer, JLabel> labelTable = new Hashtable<Integer, JLabel>();

			for (int i=1; i<=10; i++) {
				labelTable.put( new Integer( 10*i ), new JPTickLabel( ""+i ) );
			}

			setLabelTable( labelTable );
			setPaintLabels(true);
			setMajorTickSpacing(10);
			setMinorTickSpacing(5);
			setPaintTicks(true);
			addChangeListener(parent);
		}

		private class JPTickLabel extends JLabel {

			public JPTickLabel(String s) {
				super( s );
				setFont( fira.font18 );
			}

		}

		public String getValueString() {

			String s = String.format( "%.1f", (1.0*getValue() )/10 );

			if ( s.matches("[0-9]+[\\.,]0$") ) { 
				s = s.substring(0, s.length() - 2 );
			}

			return s+"%";

		}

		public Double getValueDouble() {

			return (1.0*getValue() )/1000;

		}

	}

}

