import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;

public class JShowTable extends JDialog {

	JBinomTable binomTable;

	String[] columnNames = { "k", "B ( n ; p ; k )", "F ( n ; p ; k )" };

	Object[][] data = { { "1", "0.12345678", "0.12345678" },
						{ "2", "0.12345678", "0.12345678" }  };

	JBoldTable bTable;
    
	public void showTable(String pStr, String nStr ) {

		String newHeader="( "+nStr+" ; "+pStr+" ; k )";

		bTable.getColumnModel().getColumn(1).setHeaderValue("B "+newHeader);
		bTable.getColumnModel().getColumn(2).setHeaderValue("F "+newHeader);
		bTable.getTableHeader().repaint();

		bTable.clearData();

		for (int i=0; i<= binomTable.getN(); i++) {

			bTable.addData( ""+i, 
							String.format("%.10f", binomTable.getSingle(i)),
							String.format("%.10f", binomTable.getCumulated(i))
						  );
		}

        setVisible(true);
	}

	public void hideTable() {
        setVisible(false);
	}

	public JShowTable( JBinomTable bt) {

		binomTable = bt;

		bTable = new JBoldTable(data, columnNames);

		JScrollPane scrollPane = new JScrollPane(bTable);
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		Border noborder = BorderFactory.createEmptyBorder();
		scrollPane.setBorder(noborder);
		scrollPane.setViewportBorder(noborder);
		scrollPane.setOpaque(false);

		bTable.setFillsViewportHeight(true);

		add( "Center", scrollPane );

		setTitle("Tabelle der Binomialverteilung");
		getContentPane().setPreferredSize(new Dimension(600, 400));
		pack();
		setLocationRelativeTo(null);
		setResizable(false);
		setModal(true);
		setVisible(false);

	}

}
