import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.basic.*;

class JSliderCombo extends JComboBox {

	JFiraFont fira = JFiraFont.getInstance();

	JTextField textField;

	public JSliderCombo( JBinomial p1, ActionListener p2, String start, 
						 Object[] pattern, int width) {

	super(pattern);

	setFont( fira.font22 );
//	setFont( new Font("sansserif", Font.BOLD, 16) );

    setRenderer(new SeparatorComboBoxRenderer());
    addActionListener(new SeparatorComboBoxListener(this));

	((JLabel)this.getRenderer()).setHorizontalAlignment(SwingConstants.CENTER);

	setEditable(true);
	ComboBoxEditor editor = getEditor();
	textField = (JTextField)editor.getEditorComponent();
	textField.setColumns(width);
	textField.setHorizontalAlignment(JTextField.CENTER);

	if ( start != null ) { textField.setText(start); }

	if ( p1 != null ) { addActionListener( (ActionListener) p1); }
	if ( p2 != null ) { addActionListener( p2 ); }

	setMaximumRowCount(20);
	}

	@Override
	public Dimension getMaximumSize() {
		Dimension max = super.getMaximumSize();
        max.height = getPreferredSize().height;
        return max;
    }



class SeparatorComboBoxRenderer extends BasicComboBoxRenderer implements ListCellRenderer
{
   public SeparatorComboBoxRenderer() {
      super();
   }
    
   public Component getListCellRendererComponent( JList list,
           Object value, int index, boolean isSelected, boolean cellHasFocus) {
      if (isSelected) {
          setBackground(list.getSelectionBackground());
          setForeground(list.getSelectionForeground());
      }
      else {
          setBackground(list.getBackground());
          setForeground(list.getForeground());
      }
  
      setFont(list.getFont());
      if (value instanceof Icon) {
         setIcon((Icon)value);
      }
      if (value instanceof JSeparator) {
         return (Component) value;
      }
      else {
         setText((value == null) ? "" : value.toString());
      }
  
      return this;
  } 
}
  
class SeparatorComboBoxListener implements ActionListener {
   JComboBox combobox;
   Object oldItem;
     
   SeparatorComboBoxListener(JComboBox combobox) {
      this.combobox = combobox;
      combobox.setSelectedIndex(0);
      oldItem = combobox.getSelectedItem();
   }
      
   public void actionPerformed(ActionEvent e) {
      Object selectedItem = combobox.getSelectedItem();
      if (selectedItem instanceof JSeparator) {
         combobox.setSelectedItem(oldItem);
      } else {
         oldItem = selectedItem;
      }
  }
 
} 
 
 	
}

